﻿var GismetSetting = new gismeteoSettings();

System.Gadget.onSettingsClosing = SettingsClosing;


function loadGismeteoSettings(){
	GismetSetting.load();
	loadListTowns();
      	if ((GismetSetting.countryName=="") || (GismetSetting.townName=="") || (GismetSetting.townIndex=="")){
	   GismetSetting.countryName="Россия";
	   GismetSetting.townName="Москва";
	   GismetSetting.townIndex="27612";	
        }
	loadAndShowListCountries();
	showTownList();
}

function gismeteoSettings(){
	this.tlistarray=new Array();
	this.tlistarray['townName']=new Array();
	this.tlistarray['townIndex']=new Array();
	this.tlistarray['countryName']=new Array();
	this.load=gismeteoLoadSettings;	
	this.save=gismeteoSaveSettings;
		
}

function gismeteoSaveSettings(){
	System.Gadget.Settings.write("SettingsExist", true);
	System.Gadget.Settings.write("countryName",this.countryName);
	System.Gadget.Settings.write("townName",this.townName);
	System.Gadget.Settings.write("townIndex",this.townIndex);
}

function gismeteoLoadSettings(){
    this.countryName="";
    this.townIndex="";
    this.townName="";
	
    if (System.Gadget.Settings.read("SettingsExist"))
    {
        this.countryName = unescape(System.Gadget.Settings.readString("countryName"));
        this.townIndex = parseInt(System.Gadget.Settings.read("townIndex"));
        this.townName = System.Gadget.Settings.read("townName");
    } 
}

function loadListTowns(){
   var request =new XMLHttpRequest();
   request.open("GET","http://bar.gismeteo.ru/gmbartlist.xml", false);
   request.onreadystatechange = processTownsReqChange;
   request.send();
}

function processTownsReqChange()
{
  if (this.readyState == 4){
    if (this.status == 200){
      var xrequest=this.responseXML;
      var listrecords=xrequest.documentElement.getElementsByTagName('t');
      for (i=1; i<listrecords.length;i++)
      {
	GismetSetting.tlistarray['townName'][i-1]=listrecords[i].getAttribute("n");
	GismetSetting.tlistarray['townIndex'][i-1]=listrecords[i].getAttribute("i");
	GismetSetting.tlistarray['countryName'][i-1]=listrecords[i].getAttribute("c"); 	
      }
    }
  }
}

function loadAndShowListCountries(){
   var index=0;
   var request =new XMLHttpRequest();
   request.open("GET","http://bar.gismeteo.ru/gmbarclist.xml", false);
   request.onreadystatechange = processCountriesReqChange;
   request.send();
}

function processCountriesReqChange()
{
  if (this.readyState == 4){
    if (this.status == 200){
      var xrequest=this.responseXML;
      var listrecords=xrequest.documentElement.getElementsByTagName('c');
      for (i=1; i<listrecords.length;i++)
      {
	var newOption = document.createElement("OPTION");
	newOption.value = listrecords[i].getAttribute("n");
	newOption.text = listrecords[i].getAttribute("n");

	if (newOption.text==GismetSetting.countryName) index=i-1;

	countrieslist.options[countrieslist.options.length] = newOption;
	newOption = null;			
      }
      countrieslist.selectedIndex=index;
    }
  }
}

function showTownList(){
   var index=0;
   var j=0;
   townlist.options.length=0; 

   if (GismetSetting.tlistarray['townName'].length>=1) {		
     for(i=1;i<=GismetSetting.tlistarray['townName'].length;i++){
       if (GismetSetting.tlistarray['countryName'][i]==GismetSetting.countryName){
	 var newOption = document.createElement("OPTION");
	 newOption.value = GismetSetting.tlistarray['townIndex'][i]+GismetSetting.tlistarray['townName'][i];
	 newOption.text = GismetSetting.tlistarray['townName'][i];

	 if (newOption.text==GismetSetting.townName) index=j;

	 townlist.options[townlist.options.length] = newOption;
	 newOption = null; 
	 j++;

       }
     }
   townlist.selectedIndex=index;
   }

}


function SettingsClosing(event)
{
  if ((townlist.options.length>0)&&(countrieslist.options.length>0))
  {
 	if (event.closeAction == event.Action.commit) {
		GismetSetting.countryName=countrieslist.options[countrieslist.selectedIndex].text;
		GismetSetting.townName=townlist.options[townlist.selectedIndex].text;
		GismetSetting.townIndex=townlist.options[townlist.selectedIndex].value;
		GismetSetting.save();
	}
	event.cancel = false;
  }
}